/* oooooooooooooooooooooooooooooooooo */
/* Copyright (C) 1991   P. Gburzynski */
/* oooooooooooooooooooooooooooooooooo */

/* --- */



/* --------------------------------------------- */
/* Functions for double precision BIG arithmetic */
/* --------------------------------------------- */

#include        "system.h"

#if     BIG_precision == TYPE_double

BIG     BIG_0 = 0.0, BIG_1 = 1.0, BIG_inf = HUGE;       // Constants

BIG  atob (const char *s) {             // String to BIG conversion

	BIG     r;

	while (*s == ' ') s++;
	if (*s == '+') s++;
	while (*s == ' ') s++;

	r = BIG_0;

	while ((*s <= '9') && (*s >= '0')) {
		r = r * 10 + (*s - '0');
		s++;
	}

	return (r);
}

static  char    *btoabuf = NULL;
static  int     btoable = 0;

char    *btoa (const BIG &a, char *s, int nc) {   // BIG to string

	int             i, j;
	double          al, aa;
	char            temp [40], *tm, *res;

	if (a < 0) excptn ("btoa: negative argument");

	if (s == NULL) {
		if (nc > 0 && btoable < nc) {
			if (btoable > 0) delete (btoabuf);
			btoabuf = new char [(btoable = nc) + 1];
		}
		s = btoabuf;
	}

	aa = a;
	res = s;

	tm = &(temp [39]);

	for (j = 0; j < 40; j++) {

		if (aa < 1.0) {
			if (j == 0) *--tm = '0'; else break;
			continue;
		}

		al = floor (aa / 10.0);
		i = (int) (aa - al * 10.0);
		aa = al;
		*--tm = '0' + i;
	}

	if (j <= nc) {
		while (nc-- >  j) *s++ = ' ';
		while (nc-- >= 0) *s++ = *tm++;
		*s = '\0';
		return (res);
	}

	if ((i = j - nc + 2) > 9)
		i = j - nc + 3;

	if (i >= j) {
		while (nc-- > 0) *s++ = '*';
		*s = '\0';
		return (res);
	}

	while (j-- > i) *s++ = *tm++;
	*s++ = 'E';
	if (i > 9) {
		*s++ = (j = (i/10)) + '0';
		*s++ = (i - (j * 10)) + '0';
	} else {
		*s++ = i + '0';
	}
	*s ='\0';
	return (res);
}

#endif
